unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    gbxResult: TGroupBox;
    pnlTop: TPanel;
    Label1: TLabel;
    edSearch: TEdit;
    btnSearch: TButton;
    mmResult: TMemo;
    procedure btnSearchClick(Sender: TObject);
    procedure edSearchKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses KiCompanyBasicService;

{$R *.dfm}

procedure TForm1.btnSearchClick(Sender: TObject);
var
  Client: KiCompanyBasic;
  CompanyName: String;
  SearchStr: String;
  CompanyIDData: CompanyIDDataArray;
  I : Integer;
begin
  SearchStr := Trim(edSearch.Text);

  if SearchStr = '' then
      raise Exception.Create('Puudub otsingusna');

  Client := GetKiCompanyBasic;
  if Client.isRegCodeValid(SearchStr) then
  begin
    CompanyName := Client.getName(SearchStr);
    if CompanyName <> '' then
      mmResult.Lines.Add('riregistri kood '+SearchStr+' kuulub ettevttele: '+CompanyName)
    else
      mmResult.Lines.Add('riregistri koodile '+SearchStr+' ei leitud vastavat ettevtet!');
  end else
  begin
    CompanyIDData := Client.findCompanies(SearchStr, 5);
    if Length(CompanyIDData) > 0 then
    begin
      mmResult.Lines.Add('Leiti jrgmised ettevtted:');
      for I := 0 to Length(CompanyIDData) - 1 do
        mmResult.Lines.Add(IntToStr(I+1)+' '+CompanyIDData[I].regCode+' '+CompanyIDData[I].name_);
    end else
    begin
      mmResult.Lines.Add('Ei leitud htegi "'+SearchStr+'" algavat ettevtte nime');
    end;
  end;

  Client := NIL;
end;


procedure TForm1.edSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    btnSearchClick(Self);
    Key := #0; // et ei tekiks klarist piikus!
  end;
end;

end.
